"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class InbreedingCoefficient(ProtocolElement):
    """
    Inbreeding coefficient
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "coefficient",
        "estimationMethod",
        "program",
        "sampleId",
        "version",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_5_0_0 import participant as participant_1_0_3

        return {
            "org.gel.models.participant.avro.InbreedingCoefficient": participant_1_0_3.InbreedingCoefficient,
        }

    __slots__ = [
        "coefficient",
        "estimationMethod",
        "program",
        "sampleId",
        "version",
        "standardError",
    ]

    def __init__(
        self,
        coefficient,
        estimationMethod,
        program,
        sampleId,
        version,
        standardError=None,
        validate=None,
        **kwargs
    ):
        """Initialise the participant_1_0_3.InbreedingCoefficient model.

        :param coefficient:
            Inbreeding coefficient ideally a real number in [0,1]
        :type coefficient: double
        :param estimationMethod:
            Where various methods for estimation exist, which method was used.
        :type estimationMethod: str
        :param program:
            Name of program used to calculate the coefficient
        :type program: str
        :param sampleId:
            This is the sample id against which the coefficient was estimated
        :type sampleId: str
        :param version:
            Version of the programme
        :type version: str
        :param standardError:
            Standard error of the Inbreeding coefficient
        :type standardError: None | double
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.0.3"
